#pragma once

#define CAL_BOX                        1
#define CAL_SPHERE                     2
#define CAL_CYLINDER                   3
#define CAL_CONE                       4
#define CAL_TRIANGLES                  5
#define CAL_POLYGON                    6
#define CAL_POLYGONGROUP               7
#define CAL_POLYLINE                   8
#define CAL_TETRAHEDRON                9

struct SCALResult
{
  int objID0;
  int objID1;
  scalar vector0[3];
  scalar vector1[3];
  scalar distance;
};

struct SCALBox
{
  scalar matrix[4][4];
  scalar width;
  scalar height;
  scalar depth;
};

struct SCALSphere
{
  scalar matrix[4][4];
  scalar radius;
};

struct SCALCylinder
{
  scalar matrix[4][4];
  scalar radius;
  scalar height;
};

struct SCALCone
{
  scalar matrix[4][4];
  scalar radius;
  scalar height;
};

struct SCALTriangles
{
  scalar matrix[4][4];
  int nrTriangles;
  scalar* points;
};

struct SCALPolygon
{
  scalar matrix[4][4];
  int nrPoints;
  scalar* points;
};

struct SCALPolyline
{
  scalar matrix[4][4];
  int nrLines;
  int *nrPoints;
  scalar *points;
};

struct SCALTetrahedron
{
  scalar matrix[4][4];
  scalar* points;
};